spool VAP_Update_2.7.1.log

ALTER SESSION SET CURRENT_SCHEMA = VAP;

SET SQLBLANKLINES OFF

DROP TABLE VAP.PATIENT_CONFIDENTIALITY;

DELETE FROM CONSENT_TYPE WHERE NAME = 'Withhold for Treatment Authorization';

DELETE FROM CONSENT_TYPE WHERE NAME = 'Withhold for Treatment Revocation';

--------------------------------------------------------
--  UPDATE DESCRIPTORS
--  These statements came from VAP-E team as part of Section 508 fixes
--  they made post- VAP 2.7.1. Manually "merged" them into this
--  SQL file for the VAP 2.7.2 release (eHX-E Build 3).
--------------------------------------------------------
UPDATE DESCRIPTOR SET TEXT='Move all organizations to the right box.' WHERE NAME='batchAnnounceMoveAll';
UPDATE DESCRIPTOR SET TEXT='Move the selected organizations to the right box.' WHERE NAME='batchAnnounceMoveSelectedRight';
UPDATE DESCRIPTOR SET TEXT='Move the selected organizations to the left box.' WHERE NAME='batchAnnounceMoveSelectedLeft';

COMMIT;
