<%-- 
    Document   : commentForm
    Created on : Dec 17, 2015, 1:24:09 PM
    Author     : Johann Sonnenberg
--%>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@taglib tagdir="/WEB-INF/tags/formatting" prefix="f" %>

<script>
    $(document).ready(function () {
        //because this page is generated dynamically, we need to set up the validator via JavaScript
        $('#commentForm').validator();
    });
</script>

<div id="addConsentCommentErrorMessage" class="alert alert-danger" style="display: none;" role="alert"></div>

<form name="commentForm" id="commentForm" class="form-horizontal" role="form" data-toggle="validator">
    <input type="hidden" id="consentId" name="consentId" value="<c:out value="${consentId}"/>" /> 
    <input type="hidden" id="consentType" name="consentType" value="<c:out value="${consentType}"/>" />
    <input type="hidden" id="delayedConsentId" name="delayedConsentId" value="<c:out value="${delayedConsentId}"/>" />

    <div class="form-group">
        <label for="comments" class="col-xs-2 col-sm-2 col-md-2 col-lg-2 control-label"><f:requiredField altText="Comment is a required field." labelText="Comment" /></label>
        <div class="col-xs-10 col-sm-10 col-md-10 col-lg-10">
            <textarea id="comments" name="comments" rows="5" class="form-control" required></textarea>
        </div>
    </div>
</form>